//---------------------------------------------------------
//  CCP PWM@\ɂ鐳g̔ <polling>
//      CCP    PWM@\ sing𔭐
//  Notes:  SMhzMNbN
//      PWM4KHzAf[eB250iKBPWMƂɁA
//      f[eB𐳌gɂȂ悤AύXĂB
//      ύXA80PWMňꏄ΁A4KHz/80 = 50HzƂȂA
//      4.5SIN֐f[eBɃZbg΂悢B
//          RC2        signalOut P1D
//          RC3        signalOut P1C
//          RC4        signalOut P1B
//          RC5        signalOut P1A
//  Language: MPLAB C18   Target: PIC18F14K50
//--------------------------------------------------------
#include <p18cxxx.h>
//-------------- RtBO[V ----------------------
#pragma config FOSC   = IRC  //  NbN
#pragma config PWRTEN = OFF, BOREN  = OFF, BORV   = 30
#pragma config WDTEN  = OFF, WDTPS  = 32768
#pragma config MCLRE = OFF, STVREN = ON
#pragma config PLLEN  = ON,  CPUDIV = NOCLKDIV, USBDIV = OFF
#pragma config FCMEN  = OFF, IESO   = OFF, HFOFST = OFF
#pragma config LVP    = OFF, XINST  = OFF, BBSIZ  = OFF
#pragma config CP0    = OFF, CP1 = OFF, CPB = OFF, CPD = OFF
#pragma config WRT0   = OFF, WRT1 = OFF
#pragma config WRTB   = OFF, WRTC = OFF, WRTD = OFF
#pragma config EBTR0  = OFF, EBTR1 = OFF, EBTRB = OFF

#pragma code
// ----------- g̃f[^ ----------- 
rom const unsigned char sinValue[] = 
   {
    125,135,145,154,164,173,182,190,198,206,
    213,220,226,232,236,240,244,247,248,250,
    250,250,248,247,244,240,236,232,226,220,
    213,206,198,190,182,173,164,154,145,135,
    125,115,105, 96, 86, 77, 68, 60, 52, 44,
     37, 30, 24, 18, 14, 10,  6,  3,  2,  0,
      0,  0,  2,  3,  6, 10, 14, 18, 24, 30,
     37, 44, 52, 60, 68, 77, 86, 96,105,115
    };    
//----------------------CvO------------------
void main(void){
    unsigned char cntDiv = 0;
    OSCCON = 0b01010010;                // NbN4Mhz
    TRISC  = 0b11000011;                // PortC  RC2,3,4,5o
// --------------- CCP ݒ --------------------
    CCP1CON = 0b00001100;               // VOAEg,_
    CCPR1L  = 0b00000000;               // Duty Cycle
    PSTRCON = 0b00001111;               // PWMo͂P1A,B,C,Ds
    T2CON   = 0b00000100;               //  PreS 1/1, Post 1/1
    PR2     = 0b11111001;               // PWM  249
// ---------------------------------------------
    while(1){
        while(PIR1bits.TMR2IF == 0);    // Timer2̈v҂
        PIR1bits.TMR2IF = 0;            // vtbONA
        CCPR1L = sinValue[cntDiv++];    // 4.5̐gXV
        if(cntDiv >= 80)cntDiv = 0;     // 360/4.5= 80ŌJԂ
    }
}
